using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;

namespace WpfApp3.Operations
{
    public class Operators : ObservableCollection<Operation>
    {
        public Operators(OperatorType operatorType)
        {
            switch (operatorType)
            {
                case OperatorType.String:
                    Add(new EqualOperation());
                    Add(new NotEqualOperation());
                    Add(new ContainsOperation());
                    Add(new EndsWithOperation());
                    Add(new StartsWithOperation());
                    break;
                case OperatorType.Int:
                case OperatorType.Double:
                case OperatorType.DateTime:
                    Add(new EqualOperation());
                    Add(new NotEqualOperation());
                    Add(new GreaterThanOperation());
                    Add(new GreaterThanOrEqualOperation());
                    Add(new LessThanOperation());
                    Add(new LessThanOrEqualOperation());
                    break;
                case OperatorType.Enum:
                case OperatorType.Bool:
                    Add(new EqualOperation());
                    Add(new NotEqualOperation());
                    break;
                default:
                    throw new ArgumentOutOfRangeException(nameof(operatorType), operatorType, null);
            }
        }
    }
}