﻿using System.Collections.ObjectModel;
using System.Linq;
using WpfApp3.Operations;

namespace WpfApp3
{
    public class ValidationRuleViewModel : ObservableObject
    {
        #region fields

        private Operators operators;
        private string propertyPath;
        private Operation selectedOperation;
        private object value;

        #endregion


        public ValidationRuleViewModel()
        {
            ChangeOperators();
        }


        #region properties

        public string PropertyPath
        {
            get { return propertyPath; }
            set
            {
                if (propertyPath == value) return;
                if (!IsValidPath(propertyPath)) return;

                propertyPath = value;
                ChangeOperators();
                OnPropertyChanged(nameof(PropertyPath));
            }
        }
        public Operators Operators
        {
            get { return operators; }
            set
            {
                operators = value;
                OnPropertyChanged(nameof(Operators));
            }
        }
        public Operation SelectedOperation
        {
            get { return selectedOperation; }
            set
            {
                selectedOperation = value;
                OnPropertyChanged(nameof(SelectedOperation));
            }
        }
        public object Value
        {
            get { return value; }
            set
            {
                this.value = value;
                OnPropertyChanged(nameof(Value));
            }
        }

        #endregion


        #region  private methods

        private void ChangeOperators()
        {
            OperatorType propertyType = GetPropertyType();
            Operators = new Operators(propertyType);
        }

        private OperatorType GetPropertyType()
        {
            return OperatorType.DateTime;
        }

        private bool IsValidPath(string path)
        {
            return true;
        }

        #endregion
    }
}